using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;
using System.IO;
using EnvDTE;
using SVNCOM;

namespace SVN_NET
{
	/// <summary>
	/// Summary description for CommitForm.
	/// </summary>
	public class CommitForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.Panel inputPanel;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox outputBox;
		private System.Windows.Forms.TextBox message;
		private System.Windows.Forms.Button commitButton;

		private string commitdir;
		private SVNCOM.SVN svn;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public CommitForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cancelButton = new System.Windows.Forms.Button();
			this.inputPanel = new System.Windows.Forms.Panel();
			this.message = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.commitButton = new System.Windows.Forms.Button();
			this.outputBox = new System.Windows.Forms.TextBox();
			this.inputPanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// cancelButton
			// 
			this.cancelButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancelButton.Location = new System.Drawing.Point(368, 132);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 11;
			this.cancelButton.Text = "cancel";
			// 
			// inputPanel
			// 
			this.inputPanel.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.inputPanel.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.message,
																					 this.label1});
			this.inputPanel.Location = new System.Drawing.Point(8, 12);
			this.inputPanel.Name = "inputPanel";
			this.inputPanel.Size = new System.Drawing.Size(440, 108);
			this.inputPanel.TabIndex = 12;
			// 
			// message
			// 
			this.message.AcceptsReturn = true;
			this.message.AcceptsTab = true;
			this.message.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.message.Location = new System.Drawing.Point(8, 32);
			this.message.Multiline = true;
			this.message.Name = "message";
			this.message.Size = new System.Drawing.Size(424, 64);
			this.message.TabIndex = 7;
			this.message.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(364, 16);
			this.label1.TabIndex = 5;
			this.label1.Text = "please provide a message describing the changes you made";
			// 
			// commitButton
			// 
			this.commitButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.commitButton.Location = new System.Drawing.Point(264, 132);
			this.commitButton.Name = "commitButton";
			this.commitButton.TabIndex = 10;
			this.commitButton.Text = "Commit";
			this.commitButton.Click += new System.EventHandler(this.commitButton_Click);
			// 
			// outputBox
			// 
			this.outputBox.AcceptsReturn = true;
			this.outputBox.AcceptsTab = true;
			this.outputBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.outputBox.CausesValidation = false;
			this.outputBox.Location = new System.Drawing.Point(8, 12);
			this.outputBox.Multiline = true;
			this.outputBox.Name = "outputBox";
			this.outputBox.ReadOnly = true;
			this.outputBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.outputBox.Size = new System.Drawing.Size(440, 112);
			this.outputBox.TabIndex = 13;
			this.outputBox.Text = "";
			this.outputBox.Visible = false;
			this.outputBox.WordWrap = false;
			// 
			// CommitForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(456, 166);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cancelButton,
																		  this.inputPanel,
																		  this.commitButton,
																		  this.outputBox});
			this.Name = "CommitForm";
			this.Text = "CommitForm";
			this.inputPanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void commitButton_Click(object sender, System.EventArgs e)
		{
		
			if (commitButton.Text == "OK")
			{
				this.DialogResult = DialogResult.OK;
				this.Close();
				return;
			}
			System.Threading.Thread t = new System.Threading.Thread(new ThreadStart(CommitThread));
			t.IsBackground = true;
			t.Name = "Export";
			t.Start();
			this.outputBox.Visible = true;
			this.inputPanel.Visible = false;
			this.commitButton.Text = "OK";
			this.commitButton.Enabled = false;
			this.cancelButton.Enabled = false;
		}
		private void CommitThread()
		{
			svn = new SVNCOM.SVN();
			SVNCOM._ISVNEvents_NotifyEventHandler notifyeventobj = new SVNCOM._ISVNEvents_NotifyEventHandler(this.Notify);
			svn.Notify += notifyeventobj;
			SVNCOM._ISVNEvents_PromptEventHandler prompteventobj = new SVNCOM._ISVNEvents_PromptEventHandler(this.Prompt);
			svn.Prompt += prompteventobj;
			try
			{
				Invoke(new CommitDelegate(SetMessage), new object [] {"start commit"});
				Debug.WriteLine(commitdir);
				svn.Commit(commitdir, this.message.Text,true);
				Invoke(new CommitDelegate(SetMessage), new object [] {"finished."});
				Invoke(new CommitDelegate(SetMessage), new object [] {"SVN_END"});
			}
			catch (ThreadAbortException)
			{
				Invoke(new CommitDelegate(SetMessage), new object [] {"Exception"});
			}
			catch (System.Exception ex)
			{
				System.Windows.Forms.MessageBox.Show(ex.Message,"Checkout");
				Invoke(new CommitDelegate(SetMessage), new object [] {"Exception"});
			}
			svn.Prompt -= prompteventobj;
			svn.Notify -= notifyeventobj;
		}

		private void Notify(string path, notify_action action, node_kind kind, string mime_type, notify_state content, notify_state prop, int revision)
		{
			if (revision < 1)
			{
				string str;
				notify_state _enum = ((int)content < (int)prop) ? content : prop;
				switch (_enum)
				{
					case SVNCOM.notify_state.notify_state_conflicted:
						str = "conflict!    ";
						break;
					case SVNCOM.notify_state.notify_state_inapplicable:
						str = "inapplicable ";
						break;
					case SVNCOM.notify_state.notify_state_merged:
						str = "merged       ";
						break;
					case SVNCOM.notify_state.notify_state_modified:
						str = "modified     ";
						break;
					case SVNCOM.notify_state.notify_state_unchanged:
						str = "unchanged    ";
						break;
					case SVNCOM.notify_state.notify_state_unknown:
						str = "unknown      ";
						break;
					default:
						str = "             ";
						break;
				}
				str = str + path;
				Invoke(new CommitDelegate(SetMessage), new object [] {str});
			}
			else
				Invoke(new CommitDelegate(SetMessage), new object [] {"Revision : "+revision});
		}

		private void SetMessage(string str)
		{
			if (str.IndexOf("Exception")>=0)
			{
				this.commitButton.Enabled = true;
				return;
			}
			if (str.IndexOf("SVN_END")>=0)
			{
				this.commitButton.Enabled = true;
				return;
			}
			outputBox.AppendText(str);
			outputBox.AppendText(Environment.NewLine);
		}

		private void Prompt(out string info, string prompt, bool hide)
		{
			PromptForm pf = new PromptForm();
			pf.SetValues(prompt,hide);
			info="";
			if (pf.ShowDialog()==System.Windows.Forms.DialogResult.OK)
			{
				info = pf.GetInfo();
			}
			else
				info = "";
		}

		public void SetUpdateDir(string str)
		{
			commitdir = str;
		}

	}
	public delegate void CommitDelegate(string message);

}
