using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;
using System.IO;
using EnvDTE;
using SVNCOM;

namespace SVN_NET
{
	/// <summary>
	/// Summary description for ExportForm.
	/// </summary>
	public class ExportForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel inputPanel;
		private System.Windows.Forms.TextBox repoURL;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox outputBox;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.Button exportButton;
		private System.Windows.Forms.Button browseButton;
		private System.Windows.Forms.CheckBox localCheck;

		private _DTE applicationObject;
		private SVNCOM.SVN svn;
		private System.Windows.Forms.TextBox savelocation;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ExportForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.inputPanel = new System.Windows.Forms.Panel();
			this.savelocation = new System.Windows.Forms.TextBox();
			this.repoURL = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.outputBox = new System.Windows.Forms.TextBox();
			this.cancelButton = new System.Windows.Forms.Button();
			this.exportButton = new System.Windows.Forms.Button();
			this.browseButton = new System.Windows.Forms.Button();
			this.localCheck = new System.Windows.Forms.CheckBox();
			this.inputPanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// inputPanel
			// 
			this.inputPanel.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.inputPanel.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.localCheck,
																					 this.browseButton,
																					 this.savelocation,
																					 this.repoURL,
																					 this.label2});
			this.inputPanel.Location = new System.Drawing.Point(14, 12);
			this.inputPanel.Name = "inputPanel";
			this.inputPanel.Size = new System.Drawing.Size(476, 132);
			this.inputPanel.TabIndex = 16;
			// 
			// savelocation
			// 
			this.savelocation.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.savelocation.Location = new System.Drawing.Point(128, 84);
			this.savelocation.Name = "savelocation";
			this.savelocation.Size = new System.Drawing.Size(296, 20);
			this.savelocation.TabIndex = 8;
			this.savelocation.Text = "";
			// 
			// repoURL
			// 
			this.repoURL.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.repoURL.Enabled = false;
			this.repoURL.Location = new System.Drawing.Point(128, 24);
			this.repoURL.Name = "repoURL";
			this.repoURL.Size = new System.Drawing.Size(340, 20);
			this.repoURL.TabIndex = 7;
			this.repoURL.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 88);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 16);
			this.label2.TabIndex = 6;
			this.label2.Text = "save location:";
			// 
			// outputBox
			// 
			this.outputBox.AcceptsReturn = true;
			this.outputBox.AcceptsTab = true;
			this.outputBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.outputBox.CausesValidation = false;
			this.outputBox.Location = new System.Drawing.Point(14, 12);
			this.outputBox.Multiline = true;
			this.outputBox.Name = "outputBox";
			this.outputBox.ReadOnly = true;
			this.outputBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.outputBox.Size = new System.Drawing.Size(476, 136);
			this.outputBox.TabIndex = 17;
			this.outputBox.Text = "";
			this.outputBox.Visible = false;
			this.outputBox.WordWrap = false;
			// 
			// cancelButton
			// 
			this.cancelButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancelButton.Location = new System.Drawing.Point(410, 164);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 15;
			this.cancelButton.Text = "cancel";
			// 
			// exportButton
			// 
			this.exportButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.exportButton.Location = new System.Drawing.Point(322, 164);
			this.exportButton.Name = "exportButton";
			this.exportButton.TabIndex = 14;
			this.exportButton.Text = "Export";
			this.exportButton.Click += new System.EventHandler(this.exportButton_Click);
			// 
			// browseButton
			// 
			this.browseButton.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.browseButton.Location = new System.Drawing.Point(432, 80);
			this.browseButton.Name = "browseButton";
			this.browseButton.Size = new System.Drawing.Size(32, 24);
			this.browseButton.TabIndex = 11;
			this.browseButton.Text = "...";
			this.browseButton.Click += new System.EventHandler(this.browseButton_Click);
			// 
			// localCheck
			// 
			this.localCheck.Checked = true;
			this.localCheck.CheckState = System.Windows.Forms.CheckState.Checked;
			this.localCheck.Location = new System.Drawing.Point(8, 28);
			this.localCheck.Name = "localCheck";
			this.localCheck.Size = new System.Drawing.Size(80, 16);
			this.localCheck.TabIndex = 12;
			this.localCheck.Text = "local";
			this.localCheck.CheckedChanged += new System.EventHandler(this.localCheck_CheckedChanged);
			// 
			// ExportForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 198);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.inputPanel,
																		  this.outputBox,
																		  this.cancelButton,
																		  this.exportButton});
			this.Name = "ExportForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "ExportForm";
			this.inputPanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void localCheck_CheckedChanged(object sender, System.EventArgs e)
		{
			if (localCheck.Checked)
				this.repoURL.Enabled = false;
			else
				this.repoURL.Enabled = true;
		}

		private void browseButton_Click(object sender, System.EventArgs e)
		{
			Microsoft.Samples.WinForms.Extras.FolderBrowser fb = new Microsoft.Samples.WinForms.Extras.FolderBrowser();
			if ( DialogResult.OK == fb.ShowDialog() )
				this.savelocation.Text = fb.DirectoryPath;

		}

		private void exportButton_Click(object sender, System.EventArgs e)
		{
		
			if (exportButton.Text == "OK")
			{
				this.DialogResult = DialogResult.OK;
				this.Close();
				return;
			}
			if (Directory.Exists(savelocation.Text))
			{
				if (Directory.GetFiles(savelocation.Text).Length > 0)
				{
					MessageBox.Show("The directory to export to is not empty!","error");
					return;
				}
				Directory.Delete(savelocation.Text,true);
			}
			System.Threading.Thread t = new System.Threading.Thread(new ThreadStart(ExportThread));
			t.IsBackground = true;
			t.Name = "Export";
			t.Start();
			this.outputBox.Visible = true;
			this.inputPanel.Visible = false;
			this.exportButton.Text = "OK";
			this.exportButton.Enabled = false;
			this.cancelButton.Enabled = false;
		}
		private void ExportThread()
		{
			svn = new SVNCOM.SVN();
			SVNCOM._ISVNEvents_NotifyEventHandler notifyeventobj = new SVNCOM._ISVNEvents_NotifyEventHandler(this.Notify);
			svn.Notify += notifyeventobj;
			SVNCOM._ISVNEvents_PromptEventHandler prompteventobj = new SVNCOM._ISVNEvents_PromptEventHandler(this.Prompt);
			svn.Prompt += prompteventobj;
			try
			{
				Invoke(new CommitDelegate(SetMessage), new object [] {"start export"});
				Debug.WriteLine(savelocation.Text);
				if (localCheck.Checked)
					svn.Export(Path.GetDirectoryName(applicationObject.Solution.FullName),savelocation.Text,-1);
				else
					svn.Export(repoURL.Text,savelocation.Text,-1);
				Invoke(new ExportDelegate(SetMessage), new object [] {"finished."});
				Invoke(new ExportDelegate(SetMessage), new object [] {"SVN_END"});
			}
			catch (ThreadAbortException)
			{
				Invoke(new ExportDelegate(SetMessage), new object [] {"Exception"});
			}
			catch (System.Exception ex)
			{
				System.Windows.Forms.MessageBox.Show(ex.Message,"Checkout");
				Invoke(new CommitDelegate(SetMessage), new object [] {"Exception"});
			}
			svn.Prompt -= prompteventobj;
			svn.Notify -= notifyeventobj;
		}

		private void Notify(string path, notify_action action, node_kind kind, string mime_type, notify_state content, notify_state prop, int revision)
		{
			if (revision < 1)
				Invoke(new ExportDelegate(SetMessage), new object [] {path});
			else
				Invoke(new ExportDelegate(SetMessage), new object [] {"Revision : "+revision});
		}

		private void SetMessage(string str)
		{
			if (str.IndexOf("Exception")>=0)
			{
				this.cancelButton.Enabled = true;
				return;
			}
			if (str.IndexOf("SVN_END")>=0)
			{
				this.exportButton.Enabled = true;
				return;
			}
			outputBox.AppendText(str);
			outputBox.AppendText(Environment.NewLine);
		}

		private void Prompt(out string info, string prompt, bool hide)
		{
			PromptForm pf = new PromptForm();
			pf.SetValues(prompt,hide);
			info="";
			if (pf.ShowDialog()==System.Windows.Forms.DialogResult.OK)
			{
				info = pf.GetInfo();
			}
			else
				info = "";
		}

		public void SetAppObj(_DTE appObj)
		{
			applicationObject = appObj;
		}

	}
	public delegate void ExportDelegate(string message);

}
