using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;
using System.IO;
using EnvDTE;
using SVNCOM;

namespace SVN_NET
{
	/// <summary>
	/// Summary description for SwitchForm.
	/// </summary>
	public class SwitchForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button switchButton;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.TextBox outputBox;
		private System.Windows.Forms.Panel inputPanel;
		private System.Windows.Forms.TextBox repoURL;
		private System.Windows.Forms.Label label1;

		private _DTE applicationObject;
		private SVNCOM.SVN svn;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SwitchForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.switchButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.outputBox = new System.Windows.Forms.TextBox();
			this.inputPanel = new System.Windows.Forms.Panel();
			this.repoURL = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.inputPanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// switchButton
			// 
			this.switchButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.switchButton.Location = new System.Drawing.Point(322, 164);
			this.switchButton.Name = "switchButton";
			this.switchButton.TabIndex = 14;
			this.switchButton.Text = "Switch";
			this.switchButton.Click += new System.EventHandler(this.switchButton_Click);
			// 
			// cancelButton
			// 
			this.cancelButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancelButton.Location = new System.Drawing.Point(410, 164);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 15;
			this.cancelButton.Text = "cancel";
			// 
			// outputBox
			// 
			this.outputBox.AcceptsReturn = true;
			this.outputBox.AcceptsTab = true;
			this.outputBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.outputBox.CausesValidation = false;
			this.outputBox.Location = new System.Drawing.Point(14, 12);
			this.outputBox.Multiline = true;
			this.outputBox.Name = "outputBox";
			this.outputBox.ReadOnly = true;
			this.outputBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.outputBox.Size = new System.Drawing.Size(476, 136);
			this.outputBox.TabIndex = 17;
			this.outputBox.Text = "";
			this.outputBox.Visible = false;
			this.outputBox.WordWrap = false;
			// 
			// inputPanel
			// 
			this.inputPanel.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.inputPanel.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.repoURL,
																					 this.label1});
			this.inputPanel.Location = new System.Drawing.Point(14, 12);
			this.inputPanel.Name = "inputPanel";
			this.inputPanel.Size = new System.Drawing.Size(476, 136);
			this.inputPanel.TabIndex = 16;
			// 
			// repoURL
			// 
			this.repoURL.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.repoURL.Location = new System.Drawing.Point(128, 20);
			this.repoURL.Name = "repoURL";
			this.repoURL.Size = new System.Drawing.Size(340, 20);
			this.repoURL.TabIndex = 7;
			this.repoURL.Text = "http://194.208.64.49:8080/svn/repos/";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(12, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(88, 16);
			this.label1.TabIndex = 5;
			this.label1.Text = "Branch URL:";
			// 
			// SwitchForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 198);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.switchButton,
																		  this.cancelButton,
																		  this.inputPanel,
																		  this.outputBox});
			this.Name = "SwitchForm";
			this.Text = "SwitchForm";
			this.inputPanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void switchButton_Click(object sender, System.EventArgs e)
		{
			if (switchButton.Text == "OK")
			{
				this.DialogResult = DialogResult.OK;
				this.Close();
				return;
			}
			System.Threading.Thread t = new System.Threading.Thread(new ThreadStart(SwitchThread));
			t.IsBackground = true;
			t.Name = "Switch";
			t.Start();
			this.outputBox.Visible = true;
			this.inputPanel.Visible = false;
			this.switchButton.Text = "OK";
			this.switchButton.Enabled = false;
			this.cancelButton.Enabled = false;

		}
		private void SwitchThread()
		{
			svn = new SVNCOM.SVN();
			SVNCOM._ISVNEvents_NotifyEventHandler notifyeventobj = new SVNCOM._ISVNEvents_NotifyEventHandler(this.Notify);
			svn.Notify += notifyeventobj;
			SVNCOM._ISVNEvents_PromptEventHandler prompteventobj = new SVNCOM._ISVNEvents_PromptEventHandler(this.Prompt);
			svn.Prompt += prompteventobj;

			try
			{
				Invoke(new SwitchDelegate(SetMessage), new object [] {"closing solution to unlock files"});
				string solpath = applicationObject.Solution.FullName;
				applicationObject.Solution.Close(true);
				Invoke(new SwitchDelegate(SetMessage), new object [] {"switching over to branch..."});
				svn.Switch(Path.GetDirectoryName(solpath),this.repoURL.Text,-1,true);		
				Invoke(new SwitchDelegate(SetMessage), new object [] {"reopen the solution"});
				applicationObject.Solution.Open(solpath);
				Invoke(new SwitchDelegate(SetMessage), new object [] {"finished!"});
				Invoke(new SwitchDelegate(SetMessage), new object [] {"SVN_END"});
			}
			catch (ThreadAbortException)
			{
				Invoke(new SwitchDelegate(SetMessage), new object [] {"Exception"});
			}
			catch (System.Exception ex)
			{
				System.Windows.Forms.MessageBox.Show(ex.Message,"Import");
				Invoke(new SwitchDelegate(SetMessage), new object [] {"Exception"});
			}
			svn.Prompt -= prompteventobj;
			svn.Notify -= notifyeventobj;
		}

		private void Notify(string path, notify_action action, node_kind kind, string mime_type, notify_state content, notify_state prop, int revision)
		{
			Invoke(new SwitchDelegate(SetMessage), new object [] {path});
		}

		private void SetMessage(string str)
		{
			if (str.IndexOf("Exception")>=0)
			{
				this.cancelButton.Enabled = true;
				return;
			}
			if (str.IndexOf("SVN_END")>=0)
			{
				this.switchButton.Enabled = true;
				return;
			}
			outputBox.AppendText(str);
			outputBox.AppendText(Environment.NewLine);
		}

		private void Prompt(out string info, string prompt, bool hide)
		{
			PromptForm pf = new PromptForm();
			pf.SetValues(prompt,hide);
			info="";
			if (pf.ShowDialog()==System.Windows.Forms.DialogResult.OK)
			{
				info = pf.GetInfo();
			}
			else
				info = "";
		}

		public void SetAppObj(_DTE appObj)
		{
			applicationObject = appObj;
		}


	}
	public delegate void SwitchDelegate(string message);
}
